Last modified: 2014-02-13 19:31:40 UTC

Wikimedia Bugzilla is closed!

Wikimedia has migrated from Bugzilla to Phabricator. Bug reports should be created and updated in Wikimedia Phabricator instead. Please create an account in Phabricator and add your Bugzilla email address to it.
Wikimedia Bugzilla is read-only. If you try to edit or create any bug report in Bugzilla you will be shown an intentional error message.
In order to access the Phabricator task corresponding to a Bugzilla report, just remove "static-" from its URL.
You could still run searches in Bugzilla or access your list of votes but bug reports will obviously not be up-to-date in Bugzilla.
Bug 41961 - Write redirect rules for GitBlit
Write redirect rules for GitBlit
Status: REOPENED
Product: Wikimedia
Classification: Unclassified
Apache configuration (Other open bugs)
unspecified
All All
: High normal with 1 vote (vote)
: ---
Assigned To: Nobody - You can work on this!
:
: 50398 (view as bug list)
Depends on:
Blocks: 38383 49521 50184
  Show dependency treegraph
 
Reported: 2012-11-10 09:42 UTC by Nemo
Modified: 2014-02-13 19:31 UTC (History)
10 users (show)

See Also:
Web browser: ---
Mobile Platform: ---
Assignee Huggle Beta Tester: ---


Attachments

Description Nemo 2012-11-10 09:42:26 UTC
gitweb URL should be rewritten so that they still work when we switch to GitBlit: we really don't want to update thousands of URLs on mediawiki.org alone, not to mentions all the places we can't update.
Ideally, also rewrite (some) old SVN URLs to deprecated/deleted directories: perhaps with GitBlit it will be easier, as I hear it has tree views to which we could at least fallback if there's not the specific thing one was looking for/has been redirected to.
Comment 2 Nemo 2013-06-07 06:23:21 UTC
Also the [[m:Interwiki map]] of course: MZ, can you update it?
Comment 3 MZMcBride 2013-06-07 13:31:48 UTC
(In reply to comment #2)
> Also the [[m:Interwiki map]] of course: MZ, can you update it?

I'd be happy to, I'm just not sure exactly what should be changed.
Comment 5 Chad H. 2013-06-07 13:38:08 UTC
(In reply to comment #0)
> Ideally, also rewrite (some) old SVN URLs to deprecated/deleted directories:
> perhaps with GitBlit it will be easier, as I hear it has tree views to which
> we
> could at least fallback if there's not the specific thing one was looking
> for/has been redirected to.

Wasn't planning to rewrite the SVN urls, since SVN is going to still exist as r/o.
Comment 6 Nemo 2013-06-13 09:18:47 UTC
https://gerrit.wikimedia.org/r/#/c/68110/ for LocalisationUpdate MediaWiki core was done.
For the rest, I understand some help would be needed with regex rules.
Comment 7 Gerrit Notification Bot 2013-06-25 04:32:42 UTC
Related URL: https://gerrit.wikimedia.org/r/70370 (Gerrit Change If02ce0fe0ddd8a9b692a0d2526bdbed27a762fc4)
Comment 8 Andre Klapper 2013-06-29 11:15:42 UTC
*** Bug 50398 has been marked as a duplicate of this bug. ***
Comment 9 Liangent 2013-06-29 15:38:03 UTC
Can we write a small redirector at https://gerrit.wikimedia.org/r/gitweb instead of a bunch of adhoc rewrite rules?
Comment 10 Nemo 2013-06-30 00:10:42 UTC
(In reply to comment #9)
> Can we write a small redirector at https://gerrit.wikimedia.org/r/gitweb
> instead of a bunch of adhoc rewrite rules?

It can be added after all the other redirects to catch the URLs which didn't match previous rewrites, I suppose.
Comment 11 Gerrit Notification Bot 2013-07-17 21:42:40 UTC
Change 70370 merged by Ryan Lane:
Rewrite gerrit gitweb URLs to new gitblit

https://gerrit.wikimedia.org/r/70370
Comment 12 Chad H. 2013-07-17 23:13:16 UTC
Yay :D

Thanks S for the patch, and thanks Ryan for the merge.
Comment 13 Nemo 2013-07-18 16:50:01 UTC
Thanks indeed, do we have an estimate of how many of those mediawiki.org links are still broken? I see several which either don't redirect or redirect to the git.wm.o root; some can't be replaced (like grepping URLs) but most potentially could IIRC.
Comment 14 Chad H. 2013-07-18 17:03:24 UTC
Only links I still see are: https://www.mediawiki.org/w/index.php?title=Special%3ALinkSearch&target=gerrit.wikimedia.org%2Fr%2Fgitweb

They can probably be fixed manually.

Are there others you're seeing?
Comment 15 Nemo 2013-07-18 17:18:13 UTC
See the links in comment 1 for 753+8 links as of now (they were about 1500 after the first template fixes IIRC).
Comment 17 Matthew Flaschen 2013-08-29 05:52:43 UTC
https://gerrit.wikimedia.org/r/gitweb?p=mediawiki/core.git is pretty simple and currently broken.  It redirects:

https://gerrit.wikimedia.org/r/gitweb?p=mediawiki/core.git => https://git.wikimedia.org/summary/mediawiki%252fcore%252egit/HEAD => http://git.wikimedia.org/

It would be nice to get that working.
Comment 18 spage 2013-08-29 08:16:54 UTC
(In reply to comment #17)
gitblit required '/' in project paths be changed to %2F, so my Apache mod_rewrite rules triggered URL-encoding. This worked for a while, but now the %2F is getting URL-encoded a second time which turns the '%' into %25, and gitblit chokes on the resulting %25%2f.

I suspect Christian Aistleitner's puppet commit f5a3b40b on Jun 29, which changed AllowEncodedSlashes from NoDecode to On, probably caused the break.  (Despite my copious comments as to why it needs to be that way :-) .)

I notice gitblit's own URLs to summaries are much simpler now, instead of the URL-encoded slashes after summary it is just
  http://git.wikimedia.org/summary/?r=mediawiki/core.git

That's probably simpler to implement in an Apache mod_rewrite rule rather than this fragile setup of URL-encoding exactly once. I don't know if there's a simpler format for linking to a file within a project, the same rewrite rules also used to rewrite to
   https://git.wikimedia.org/raw/mediawiki%2fextensions%2fexamples.git/HEAD/BoilerPlate%2fREADME

which now has %25%2f s and is likewise broken.

Chad, are gitblit URLs documented anywhere?
Comment 19 Chad H. 2013-08-29 14:08:58 UTC
Not to my knowledge
Comment 20 spage 2013-08-29 19:58:56 UTC
Christian Aistleitner points out his check-in long predated mine (d'oh, sorry), so that isn't what changed; but while testing on my local Apache I did have to set AllowEncodedSlashes to NoDecode even though it was never in my patch. Someone could try this in the config, I don't know what else it would break.
Comment 21 Matthew Flaschen 2013-08-29 20:22:32 UTC
The confusion was caused by the rebase.  In patch set 1 of S's patch (https://gerrit.wikimedia.org/r/#/c/70370/1/templates/apache/sites/gerrit.wikimedia.org.erb), NoDecode was on in both sides.  In patch set 2 (after rebase), it was "AllowEncodedSlashes On" on both sides (https://gerrit.wikimedia.org/r/#/c/70370/2/templates/apache/sites/gerrit.wikimedia.org.erb).
Comment 22 Gerrit Notification Bot 2013-08-30 21:22:07 UTC
Change 82044 had a related patch set uploaded by QChris:
Fix double encoded characters in gitweb -> gitblit forwards

https://gerrit.wikimedia.org/r/82044
Comment 23 Gerrit Notification Bot 2013-09-03 16:24:12 UTC
Change 82044 merged by Ottomata:
Fix double encoded characters in gitweb -> gitblit forwards

https://gerrit.wikimedia.org/r/82044
Comment 24 spage 2013-09-03 19:08:22 UTC
The test cases at https://git.wikimedia.org/blob/operations%2Fpuppet.git/3c9c28f2c869c3eee471d9bf4aced12c3de9a039/templates%2Fapache%2Fsites%2Fgerrit.wikimedia.org.erb#L98 all work again, yay!

In reply to comment #18

>   http://git.wikimedia.org/summary/?r=mediawiki/core.git
> 
> That's probably simpler to implement in an Apache mod_rewrite rule rather
> than
> this fragile setup of URL-encoding exactly once.

Until we figure out if there's also a simpler query string URL for linking to project files, we should stick to this complex but consistent approach.
Comment 25 Nemo 2013-09-03 19:14:56 UTC
For the records, the LinkSearch queries of comment 1 now find "only" 463+8 links. I've not counted how many work.

Note You need to log in before you can comment on or make changes to this bug.


Navigation
Links